import greenfoot.*;

public class Wingman extends Unit
{
    public static int count; // counts the number of instances created from this class
    
    private int id; // identification number of this instance
    
    public Wingman()
    {
        id = count;
        count++;
    }

    public void act()
    {
        // get rotation of leader
        int r = Unit.leader.getQR();
        // save current location
        int x = getQX();
        int y = getQY();
        // determine where we should be
        setQLocation(Unit.leader.getQX(), Unit.leader.getQY());
        setQRotation(r);
        move(-(id/2+1)*80*QActor.QVAL);
        move(-(id/2+1)*40*QActor.QVAL, r+90*(1-2*(id%2))*QActor.QVAL);
        int destX = getX();
        int destY = getY();
        // move back to saved current location
        setQLocation(x, y);
        // adjust speed toward that of leader
        if (leader.speed > speed) speed++;
        if (leader.speed < speed) speed--;
        // move
        move(speed);
        // move toward where we should be
        turnTowards(destX, destY);
        if (Math.hypot(x/100-destX, y/100-destY) > 2) move(100*(id/2+1));
        // set rotation to that of leader
        setQRotation(r);
        // set image to that of leader
        setImage(Unit.leader.getImage());
    }
}